{% extends 'admin/adminbase.html.twig' %}
{% import "macros/datatable.html.twig" as dt %}
{#{% import "macros/datatableSubject.html.twig" as dt %}#}
{% import "macros/genCheckBox.html.twig" as cb %}
{% import "macros/genLoading.html.twig" as ld %}
{% block moreCss %}
    <link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/css/select2.min.css" rel="stylesheet"/>
    <link href="{{ asset('dropify/css/dropify.css') }}" rel="stylesheet">

{% endblock %}
{% block body %}
    <h5>Harga Pengajar</h5>
    <div class="row">
        {% for a in parrent %}
            <div class="col col-md-6 col-sm-6 mb-4 ">
                <div class="card-genossys pb-0" id="div{{ a.idtb|replace({' ':''}) }}">
                    <div class="row">
                        <div class="col col-6" id="lb{{ a.idtb|replace({' ':''}) }}">
                            <label class="font-weight-bold">{{ a.name }}</label>
                        </div>
                        <div class="col col-6  text-right">
                            <a class="btn btn-sm " data-id="{{ a.id }}" data-name="{{ a.name }}" data-lbid="{{ a.idtb|replace({' ':''}) }}" id="editParent"><i class="fa fa-pencil" id="iconEdit"
                                                                                                                                                               aria-hidden="true"></i></a>
                            <a class="btn btn-sm " data-id="{{ a.id }}" data-name="{{ a.name }}" id="deleteParent"><i class="fa fa-trash" aria-hidden="true"></i></a>
                        </div>
                    </div>
                    {{ dt.datatable(a.idtb) }}
                    <div class="text-center mb-0" style="border-top: 1px solid #939393">
                        <a class="btn text-blue" data-id="{{ a.id }}" data-tbid="{{ a.idtb|replace({' ':''}) }}" id="addPricing" onclick=""><i class="fa fa-plus" aria-hidden="true"></i> Tambah
                            Kategori</a>
                    </div>
                </div>
            </div>
        {% endfor %}
        <div class="col col-md-6 col-sm-6" style="">
            <div style="" class="border-dashed text-center align-content-center">
                <a class="btn" onclick="modalParentCategori()" style="height: 100px; display: flex; align-items: center; justify-content: center;"><i class="fa fa-plus" aria-hidden="true"></i> Tambah
                    Parent
                    Kategori</a>
            </div>
        </div>
    </div>
    <div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <form id="subjectForm" method="post" onsubmit="">
                    <input id="id" name="id" hidden>
                    <input id="idParent" name="idParent" hidden>
                    <input id="idCategory" name="idCategory" hidden>
                    <input id="action" name="action" hidden>
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Data Subject</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="row">
                            <div class="form-group col-sm-12 ">
                                <label for="category">Mata Pelajaran</label>
                                <div class="row">
                                    <div class="col-10 pr-0">
                                        <select id="category" onchange="changeData(this)" class="form-control" name="category" style="width: 100%">
                                            <option value="">Pilih Mata Pelajaran</option>
                                        </select>
                                    </div>
                                    <div class="col-2">
                                        <a class="btn btn-sm btn-success" href="#!" id="addSubject"><i class="fa fa-plus" aria-hidden="true"></i></a>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group col-sm-12">
                                <label for="method">Metode</label>
                                {{ cb.checkBox() }}
                            </div>

                            <div class="form-group col-sm-12 ">
                                <label for="level">Jenjang</label>
                                {{ cb.checkBox('jenjang') }}
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="button" onclick="sendData()" class="btn btn-primary">Simpan</button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    <div class="modal fade" id="modalAddSubject" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <form id="formCategori">
                    <input id="actionCate" name="action" value="add" hidden>
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">Form Subjek</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="subjek">Nama Mapel : </label>
                            <input type="text" class="form-control" id="name" name="name" placeholder="Nama Mapel">
                        </div>
                        <fieldset class="form-group">
                            <label for="subjek">Pengaturan Lanjutan : </label>

                            <div class="row">
                                <div class="col col-md-4">
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" value="1" id="isReference" name="isReference">
                                        <label class="form-check-label" for="isReference">
                                            Referensi
                                        </label>
                                    </div>
                                </div>
                                <div class="col col-md-4">
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" value="1" id="isDefault" name="isDefault">
                                        <label class="form-check-label" for="isDefault">
                                            Default
                                        </label>
                                    </div>
                                </div>
                                <div class="col col-md-4">
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" value="1" id="isPopular" name="isPopular">
                                        <label class="form-check-label" for="isPopular">
                                            Populer
                                        </label>
                                    </div>
                                </div>
                            </div>
                        </fieldset>
                        <div class="form-group">
                            <label for="subjek">Icon : </label>
                            <div class="input-field" id="div-img">
                                <input type="file" onchange="" id="icon" class="icon" data-min-height="10"
                                       data-height="150"
                                       accept="image/jpeg, image/jpg, image/png"
                                       data-allowed-file-extensions="jpg jpeg png"
                                />
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Simpan</button>
                    </div>

                </form>
            </div>
        </div>
    </div>
    {{ ld.modal_loading() }}
{% endblock %}
{% block javascripts %}
    <script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/js/select2.min.js"></script>
    <script src="{{ asset('dropify/js/dropify.js') }}"></script>
    <script type="text/javascript"
            src="https://cdn.jsdelivr.net/npm/browser-image-compression@latest/dist/browser-image-compression.js"></script>
    <script src="{{ asset('etc/js/currency.js') }}"></script>
    <script>
         function sendData() {
            if ($('#category').val() === '') {
                alertify.alert('Warning', 'Silahkan masukkan data Mata Pelajaran !', function () {
                    $('#category').focus()
                });
            } else {
                alertify.confirm('Info', 'Apakah anda yakin untuk menyimpan data ?', function () {
                    $('#loading').modal();
                    // document.getElementById('subjectForm').submit();
                     $.post('/admin/pengaturan/subject',$('#subjectForm').serialize(), function (data) {
                        $('#loading').modal('hide');
                        $('#modal').modal('hide');
                        console.log(data['payload']['tbId']);
                        $('#'+data['payload']['tbId']).DataTable().ajax.reload();
                    })
                }, function () {
                }).set('labels', {ok: 'Ya', cancel: 'Tidak'}).set({transition: 'fade'});
            }

        }

        $(document).ready(function () {
            currency('price');

            getCategory('{{ path('getCategory') }}', 'category');
            $('#category').select2();

            var fr = $('#formCategori');
            fr.submit(async function (e) {
                e.preventDefault(e);
                var formData = new FormData(this);

                alertify.confirm("Tambah Data Subject", "Apakah data yang anda masukkan sudah benar ?",
                    async function () {
                        if ($('#modalAddSubject #icon').val()) {
                            let icon = await handleImageUpload($('#icon'));

                            formData.append('icon', icon, icon.name);
                        }
                        console.log(formData);
                        $('#loading').modal();

                        $.ajax({
                            url: "/admin/pengaturan/mata-pelajaran",
                            type: "POST",
                            success: function (data, response) {
                                if (response === 'success') {
                                    $('#modalAddSubject').modal('hide');
                                    getCategory('{{ path('getCategory') }}', 'category');
                                    $('#category').select2();
                                    $('#loading').modal('hide');
                                }
                                // window.location.reload();

                            },
                            error: function (error) {
                                console.log("LOG ERROR", error);
                                // handle error
                            },
                            async: true,
                            data: formData,
                            cache: false,
                            contentType: false,
                            processData: false,
                            timeout: 60000
                        })
                    }, function () {

                    }
                )

            });

        });

         function changeData(a){
             var category = $(a).val();
             var parent = $('#idParent').val();
             editData(category, parent);
         }

         $(document).on("click", "a#editData", function () {
             var categoryId = $(this).data("categoryid").toString();
             var parentId = $(this).data("cred").toString();
             var method = $(this).data("method") === '' ? '0' : $(this).data("method");

             $('#idCategory').val(categoryId);
             $('#idParent').val(parentId);
             $('#category').val(categoryId).trigger('change').select2();


            editData(categoryId, parentId);
         });

        function editData(category,parent) {
            var categoryId = category;
            var parentId = parent;
            // $('#idCategory').val(categoryId);
            // $('#idParent').val(parentId);
            // $("#modal #action").val('edit');
            // $('#category').val(categoryId).trigger('change').select2();
            $('.checktext').prop("checked", false);
            $('.classid').val('');
            let data = {
                'categoryId': categoryId,
                'parentId': parentId
            };

            $("#modal #action").val('add');

            $.get('/admin/pengaturan/get-data-subject',data, async function (data) {
                if (data['code'] === 200) {

                    var pay = data['payload'];
                    await $.each(pay['level'], function (key, value) {
                        $('#idjenjang'+key).val(value['idFild']);
                        if (value['name']){
                            $("#modal #action").val('edit');

                            $('#jenjang' + value['name'].split(' ').join('')).prop("checked", true);
                            $('#jenjang' + value['name'].split(' ').join('')+'hidden').attr('disabled','');
                        }
                    });

                   await $.each(pay['method'], function (key, value) {
                       $('#idmethod'+key).val(value['idFild']);
                       if (value['name']){
                           $("#modal #action").val('edit');

                           $('#method' + value['name'].split(' ').join('')).prop("checked", true);
                            $('#method' + value['name'].split(' ').join('')+'hidden').attr('disabled','');

                        }
                    });
                }
            });
            // selectElement('category',$(this).data("categoryid"));
            $("#modal").modal();
        }

        $(document).on("click", "a#addPricing", function () {
            $("#modal #idParent").val($(this).data("id"));
            $('.checktext').prop("checked", false);
            $('#category').val('').trigger('change').select2();
            $("#modal #idSubject").val('');
            $("#modal #id").val('');
            $("#modal #action").val('add');
            $("#modal #city").val('');
            $("#modal #category").val('');
            $("#modal #level").val('');
            $("#modal #grade").val('');
            $("#modal #price").val('');
            $("#modal #method").val('');
            $('.classid').val('');

            $("#modal").modal();

        });

        $(document).on("click", "a#addSubject", function () {
            $('#modalAddSubject').modal();
            $('.icon').dropify({
                defaultFile: '',
                messages: {
                    'default': 'Masukkan Gambar Icon',
                    'replace': 'Drag and drop or click to replace',
                    'remove': 'Remove',
                    'error': 'Ooops, something wrong happended.'
                }
            });
        });

        function selectElement(id, valueToSelect) {
            console.log(valueToSelect);
            let element = document.getElementById(id);
            element.value = valueToSelect;
        }

        $(document).on("click", "a#deleteSubject", function (ev) {
            var parent = $(this).data('cred');
            var category = $(this).data('idcategory');
            var tbid = $(this).data('tbid');
            var name = $(this).data('category');

            alertify.confirm('Warning', 'Apakah anda yakin untuk menghapus data ' + name + ' ?', function () {

                    $.ajax({
                        url: '{{ path('delete-subject') }}',
                        method: 'POST',
                        data: {
                            'parent': parent,
                            'category': category
                        },
                        success: function (data) {
                            $('#' + tbid).DataTable().ajax.reload();
                            console.log(data);
                            alertify.notify(data['status'], data['label'], 5, function () {
                                console.log('dismissed');
                            });
                        }
                    });

                }
                , function () {
                    // showToast('Data tidak dihapus', 'warning');
                    alertify.notify('Data tidak dihapus', 'danger', 5, function () {
                        console.log('dismissed');
                    });

                }
            ).set({transition: 'fade'});
        });

        $(document).on('change', '#method', function () {
            $('#city').removeAttr('disabled');
            if ($(this).val() == '1') {
                $('#city').attr('disabled', '');
                $('#city').val("");
            }

        });

        $(document).on('click', 'a#deleteParent', function () {
            var id = $(this).data('id');
            var name = $(this).data('name');
            alertify.confirm('Warning', 'Apakah anda yakin untuk menghapus data ' + name + ' ?'
                , function (evt, value) {
                    let data = {
                        'id': id
                    };
                    console.log(data)
                    $.post('/admin/pengaturan/delete-parent-category', data, function (data) {
                        console.log(data);
                        if (data['code'] === 200) {
                            window.location.reload()
                        }else {
                            alertify.alert('Gagal menghapus data '+name, 'Ada data mata pelajaran yang belum dihapus')
                        }
                    });

                }
                , function () {
                });
        });

        $(document).on("click", 'a#editParent', function (ev) {
            // $('#lb'+$(this).data('lbid')).html('<input type="text" id="txt'+$(this).data('lbid')+'" data-default="'+$(this).data('name')+'" onfocusout="closeBtn()" value="'+$(this).data('name')+'">');
            // $('#txt'+$(this).data('lbid')+'').focus();
            // $('#div'+$(this).data('lbid')+' #editParent').html('<i class="fa fa-save" id="iconSave" aria-hidden="true"></i>')
            var id = $(this).data('id');
            alertify.prompt('Form Edit Nama Kategori', 'Masukkan Nama Kategori', $(this).data('name')
                , function (evt, value) {
                    let data = {
                        'name': value,
                        'id': id
                    };
                    if (value !== '') {
                        $.post('/admin/pengaturan/edit-parent-category', data, function (data) {
                            console.log(data);
                            if (data['code'] === 200) {
                                window.location.reload()
                            }
                        });
                    } else {
                        alertify.warning('Masukkan data dengan benar !');
                    }

                }
                , function () {
                });
        });

        {#function closeBtn() {#}
        {#    console.log('asdasd');#}
        {#<label class="font-weight-bold">{{ a.name }}</label>#}
        {#}#}
        function getCategory(url, select1) {
            var select = $('#' + select1);
            $.get(url, function (data) {
                if (data['code'] === 200) {
                    $.each(data['payload'], function (key, value) {
                        // if (a && a === value['id']) {
                        //     select.append('<option value="' + value['id'] + '" selected>' + value['name'] + '</option>')
                        // } else {
                        select.append('<option value="' + value['id'] + '">' + value['name'] + '</option>')
                        // }
                    });
                }
                // $('#' + select1).formSelect();

            })
        }

        function modalParentCategori() {
            alertify.prompt('Form Nama Kategori', 'Masukkan Nama Kategori', ''
                , function (evt, value) {
                    let data = {
                        'name': value
                    };
                    if (value !== '') {
                        $.post('/admin/pengaturan/add-parent-category', data, function (data) {
                            console.log(data);
                            if (data['code'] === 200) {
                                window.location.reload()
                            }
                        });
                    } else {
                        alertify.warning('Masukkan data dengan benar !');
                    }

                }
                , function () {
                });
        }

        function modalCategori() {
            <!-- the form to be viewed as dialog-->

            alertify.genericDialog || alertify.dialog('genericDialog', function () {
                return {
                    main: function (content) {
                        this.setContent(content);
                    },
                    build: function () {
                        var errorHeader = 'Form Categori';
                        this.setHeader(errorHeader);
                    },
                    setup: function () {
                        return {
                            focus: {
                                element: function () {
                                    return this.elements.body.querySelector(this.get('selector'));
                                },
                                select: true
                            },

                            options: {
                                basic: true,
                                maximizable: false,
                                resizable: false,
                                padding: false
                            }
                        };
                    },
                    settings: {
                        selector: undefined
                    }
                };
            });
//force focusing password box
            alertify.genericDialog('<div class="p-3">\n' +
                '        <form id="loginForm">\n' +
                '            <div class="row">\n' +
                '                <div class="form-group col-sm-12 col-md-6">\n' +
                '                    <label for="subjek">Subjek</label>\n' +
                '                    <select id="subjek" class="form-control" name="subjek">\n' +
                '                        <option>Subjek</option>\n' +
                '                    </select>\n' +
                '                </div>\n' +
                '                <div class="form-group col-sm-12 col-md-6">\n' +
                '                    <label for="exampleInputPassword1">Jenjang</label>\n' +
                '                    <select id="subjek" class="form-control" name="subjek">\n' +
                '                        <option>Jenjang</option>\n' +
                '                    </select>\n' +
                '                </div>\n' +
                '                <div class="form-group col-sm-12 col-md-6">\n' +
                '                    <label for="jabatan">Kota</label>\n' +
                '                    <select id="subjek" class="form-control" name="subjek">\n' +
                '                        <option>Kota</option>\n' +
                '                    </select>\n' +
                '                </div>\n' +
                '                <div class="form-group col-sm-12 col-md-6">\n' +
                '                    <label for="jabatan">Grade</label>\n' +
                '                    <select id="subjek" class="form-control" name="subjek">\n' +
                '                        <option>Grade</option>\n' +
                '                    </select>\n' +
                '                </div>\n' +
                '                <div class="form-group col-sm-12 col-md-6">\n' +
                '                    <label for="jabatan">Method</label>\n' +
                '                    <select id="subjek" class="form-control" name="subjek">\n' +
                '                        <option>Grade</option>\n' +
                '                    </select>\n' +
                '                </div>\n' +
                '                <div class="form-group col-sm-12 col-md-6">\n' +
                '                    <label for="jabatan">Harga</label>\n' +
                '                    <input type="text" class="form-control" id="price" name="price" placeholder="20.000">\n' +
                '                </div>\n' +
                '                <div class="form-group col-sm-12 text-center">\n' +
                '                    <input type="submit" class="btn btn-primary btn-blue" value="Save"/>\n' +
                '                </div>\n' +
                '            </div>\n' +
                '        </form>\n' +
                '    </div>').set('selector', 'input[type="password"]');

        }
    </script>
    {% for a in parrent %}
        {{ dt.datatableJS(class, space, tableAction, tableFields,a.where,groupBy,null,null,a.idtb) }}
        {#        {{ dt.datatableJS(a.idtb,a.id) }}#}
    {% endfor %}
    {{ cb.checkBoxJs('get-method') }}
    {{ cb.checkBoxJs('getLevel', 'jenjang') }}
{% endblock %}